unit colorset_ecran;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls;

type

  { TWdEcran }

  TWdEcran = class(TForm)
    Img1: TImage;
    procedure FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure Img1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdEcran: TWdEcran;

implementation

uses colorset_main;

{$R *.lfm}

{ TWdEcran }

var
  MaxX, MaxY: integer;

procedure Graphe(Col: TColor);
const
  ColH: array[1..8] of integer = (
    0, 60, 180, 120, 300, 0, 240, 0);
  ColNb: array[1..8] of integer = (
    100, 87, 75, 62, 50, 37, 25, 12);

var
  CoefL: real;
  MaxX, MaxY: integer;
  DeltaX, DeltaY: integer;
  DeltaNB, Nb: integer;
  H, S, L, n, p, x: integer;
  R, G, B: byte;
begin
  with WdEcran do
  begin
    MaxX := WdEcran.Width;
    MaxY := WdEcran.Height;
    CoefL := 100 / MaxX;
    with Img1.Canvas do
    begin
      if WdMain.Mire then
      begin
        DeltaX := MaxX div 8;
        DeltaY := MaxY - (MaxY div 3);
        DeltaNB := 100 div 8;
        x := 0;
        p := 1;
        //Blanc
        Pen.Color := ClWhite;
        repeat
          //Blanc, Jaune, Bleu clair, Vert
          //Violet, Rouge, Bleu foncé, Noir
          S := 100;
          L := 50;
          case p of
            1: L := 100;
            8: L := 0;
            else
              L := 50;
          end;
          //Détermination du RGB par HSL
          WdMain.HSLtoRGB_H360_S100_L100_RGB255(ColH[p], S, L, R, G, B);
          Pen.Color := RGBToColor(R, G, B);
          for n := x to x + DeltaX - 1 do
            Line(n, 0, n, DeltaY);
          //Degradé noir et blanc
          S := 0;
          L := ColNb[p];
          for n := x to x + DeltaX - 1 do
          begin
            WdMain.HSLtoRGB_H360_S100_L100_RGB255(ColNb[p], S, L, R, G, B);
            Pen.Color := RGBToColor(R, G, B);
            Line(n, DeltaY, n, maxY);
            L := Round(L + CoefL);
          end;
          //-
          x := x + DeltaX;
          Inc(p);
        until x > MaxX;
      end
      else
      begin
        Pen.Color := Col;
        for n := 0 to MaxX - 1 do
          Line(n, 0, n, MaxY - 1);
      end;
      if WdMain.Ck1.Checked then
        Img1.Canvas.TextOut(MaxX div 4, MaxY div 4,
          'Clic sur l''écran pour revenir au menu...');
    end;
  end;
end;

procedure TWdEcran.Img1Click(Sender: TObject);
begin
  WdEcran.Close;
end;

procedure TWdEcran.FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key in [13, 27, 32] then
    WdEcran.Close;
end;

procedure TWdEcran.FormShow(Sender: TObject);
begin
  MaxX := Screen.Width;
  MaxY := Screen.Height;
  WdEcran.Width := MaxX;
  WdEcran.Height := MaxY;
  WdEcran.Left := 0;
  WdEcran.Top := 0;
  Graphe(WdMain.Col);
end;

end.
