unit colorset_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TWdMain }

  TWdMain = class(TForm)
    Ck1: TCheckBox;
    Img: TImage;
    LaX: TLabel;
    LaR: TLabel;
    LaG: TLabel;
    LaB: TLabel;
    LaC: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    PaColor: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    PaRGB: TPanel;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure ImgClick(Sender: TObject);
    procedure ImgMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure Panel2Click(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
    procedure Panel4Click(Sender: TObject);
    procedure Panel5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    Col: TColor;
    Mire: boolean;
    procedure HSLtoRGB_H360_S100_L100_RGB255(H, S, L: integer; var R, G, B: byte);
  end;

var
  WdMain: TWdMain;
  Hx: integer;

implementation

uses colorset_ecran;

{$R *.lfm}

{ TWdMain }

procedure TWdMain.HSLtoRGB_H360_S100_L100_RGB255(H, S, L: integer; var R, G, B: byte);
var
  Sat, Lum: double;
begin
  //Entrée : H:0 à 360, S:0 à 100, L:0 à 100
  //Sortie : R:0 à 255, G:0 à 255, B:0 à 255
  R := 0;
  G := 0;
  B := 0;
  if ((H >= 0) and (H <= 359)) and ((S >= 0) and (S <= 100)) and
    ((L >= 0) and (L <= 100)) then
  begin
    if H <= 60 then
    begin
      R := 255;
      G := Round((255 / 60) * H);
      B := 0;
    end
    else if H <= 120 then
    begin
      R := Round(255 - (255 / 60) * (H - 60));
      G := 255;
      B := 0;
    end
    else if H <= 180 then
    begin
      R := 0;
      G := 255;
      B := Round((255 / 60) * (H - 120));
    end
    else if H <= 240 then
    begin
      R := 0;
      G := Round(255 - (255 / 60) * (H - 180));
      B := 255;
    end
    else if H <= 300 then
    begin
      R := Round((255 / 60) * (H - 240));
      G := 0;
      B := 255;
    end
    else if H <= 359 then
    begin
      R := 255;
      G := 0;
      B := Round(255 - (255 / 60) * (H - 300));
    end;
    Sat := Abs((S - 100) / 100);
    R := Round(R - ((R - 128) * Sat));
    G := Round(G - ((G - 128) * Sat));
    B := Round(B - ((B - 128) * Sat));
    Lum := (L - 50) / 50;
    if Lum > 0 then
    begin
      R := Round(R + ((255 - R) * Lum));
      G := Round(G + ((255 - G) * Lum));
      B := Round(B + ((255 - B) * Lum));
    end
    else if Lum < 0 then
    begin
      R := Round(R + (R * Lum));
      G := Round(G + (G * Lum));
      B := Round(B + (B * Lum));
    end;
  end;
end;

procedure Init;
var
  MaxY: integer;
  H, S, L: integer;
  R, G, B: byte;
begin
  with WdMain do
  begin
    MaxY := Img.Height - 1;
    R:=0;G:=0;B:=0;
    with Img.Canvas do
    begin
      S := 50;
      L := 50;
      for H := 0 to 359 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(H, S, L, R, G, B);
        Pen.Color := RGBToColor(R, G, B);
        Line(H, 0, H, MaxY);
      end;
    end;
    Hx := 188;
    Mire := False;
  end;
end;

procedure TWdMain.Panel2Click(Sender: TObject);
begin
  Col := ClWhite;
  WdEcran.Show;
end;

procedure TWdMain.Panel3Click(Sender: TObject);
begin
  Col := ClBlack;
  WdEcran.Show;
end;

procedure TWdMain.Panel4Click(Sender: TObject);
begin
  Mire := True;
  WdEcran.Show;
  Mire := False;
end;

procedure TWdMain.ImgClick(Sender: TObject);
begin
  WdEcran.Show;
end;

procedure TWdMain.Panel5Click(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.Timer1Timer(Sender: TObject);
var
  H, S, L: integer;
  R, G, B: byte;
begin
  with WdMain do
  begin
    LaX.Caption := 'H : ' + IntToStr(Hx);
    H := Hx;
    S := 50;
    L := 50;
    R:=0;
    G:=0;
    B:=0;
    HSLtoRGB_H360_S100_L100_RGB255(H, S, L, R, G, B);
    Col := RGBToColor(R, G, B);
    PaColor.Color := Col;
    LaR.Caption := 'Red : ' + IntToStr(R);
    LaG.Caption := 'Green : ' + IntToStr(G);
    LaB.Caption := 'Blue : ' + IntToStr(B);
    LaC.Caption := 'TColor : ' + IntToStr(Col);
  end;
end;

procedure TWdMain.ImgMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
begin
  Hx := X;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  //Pour le HSL de
  WdMain.Width := 399;
  Col := $00AAE8FF;
  Init;
end;

end.
